<?php  
/* 
Plugin Name: flickr Widget 
Plugin URI:  http://www.wildbits.de
Description: Simple widget to get the latest pictures form a flickr stream 
Version: 1.0.0 
Author: Thomas Boley
Author URI: http://www.wildbits.de 
*/  

/*

includes

*/

include('flickrConnect_class.php');
include('templateParser_class.php');

/*

class flickget

*/

class flickget extends WP_Widget {  
    
    function flickget() {  
        parent::WP_Widget(false, $name = 'flickget');     
    }  
  

    function widget($args, $instance) { 
          
        extract( $args );  
        echo $before_widget; 
        echo $before_title.$instance['title'].$after_title;  
                  	
		$flickr_gallery = new flickr_connect ($instance['apicode']);
		$rsp_obj = $flickr_gallery->flickr_peoplefindByUsername($instance['user']);

		$rsp_obj = $flickr_gallery->flickr_peopleGetPublicPhotos($rsp_obj['user']['id'],$instance['photos']);
		
		$content = '';
		
		foreach ($rsp_obj['photos']['photo'] as $single_photo_array) {
		$url_param = 'http://farm'.$single_photo_array['farm'].'.static.flickr.com/'.$single_photo_array['server'].'/'.$single_photo_array['id'].'_'.$single_photo_array['secret'];
		$url_param_t = $url_param.'_s.jpg';
		$url_param_o = $url_param.'.jpg';
	
		$innerTemplate= new  templateparser(PLUGINDIR.'/flickget/frontend_tmpl.html');
		$innerTemplate->set_parameter('USERNAME',$instance['user']);
		$innerTemplate->set_parameter('PHOTOID',$single_photo_array['id']);
		$innerTemplate->set_parameter('SRC',$url_param_t);
		$innerTemplate->set_parameter('TITLE',$single_photo_array['title']);
		
		$content .=$innerTemplate->get_output();

	
}
	$wrapTemplate = new  templateparser(PLUGINDIR.'/flickget/wrap_tmpl.html');
	$wrapTemplate->set_parameter('CONTENT',$content);
	$wrapTemplate->set_parameter('PLUGINPATH',PLUGINDIR.'/flickget');
		
	$wrapTemplate->the_output();
	
	echo $after_widget;   
         
    }  
  
    function update($new_instance, $old_instance) {               
        
        $instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['apicode'] = strip_tags($new_instance['apicode']);
		$instance['user'] = strip_tags($new_instance['user']);
		$instance['photos'] = strip_tags($new_instance['photos']);
		
		return $instance;
    }  
  

    function form($instance) {  
                  
        $title = esc_attr($instance['title']);
        $apicode = esc_attr($instance['apicode']);
        $user = esc_attr($instance['user']);
        $photos = esc_attr($instance['photos']);  
        
        $innerTemplate= new  templateparser(ABSPATH.PLUGINDIR.'/flickget/backend_tmpl.html');
        
        $innerTemplate->set_parameter('FIELDTITLEID',$this->get_field_id('title'));
        $innerTemplate->set_parameter('FIELDTITLE',__('Title:'));
        $innerTemplate->set_parameter('FIELDNAMETITLE',$this->get_field_name('title'));
        $innerTemplate->set_parameter('TITLE',$title);
        $innerTemplate->set_parameter('APICODE',$apicode);
        $innerTemplate->set_parameter('APICODEID',$this->get_field_id('apicode'));
        $innerTemplate->set_parameter('APICODENAME',$this->get_field_name('apicode'));
        $innerTemplate->set_parameter('USER',$user);
        $innerTemplate->set_parameter('USERNAMEID',$this->get_field_id('user'));
        $innerTemplate->set_parameter('USERNAME',$this->get_field_name('user'));
        $innerTemplate->set_parameter('PHOTOS',$photos);
        $innerTemplate->set_parameter('PHOTOSID',$this->get_field_id('photos'));
        $innerTemplate->set_parameter('PHOTOSNAME',$this->get_field_name('photos'));        
        
        $innerTemplate->the_output(); 
    }  
}  

add_action('widgets_init', create_function('', 'return register_widget("flickget");'));  
?>